import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;
import java.net.*;
import java.awt.datatransfer.*;
import com.Ostermiller.util.Base64;

public class base64encoder extends JFrame implements ActionListener, WindowListener
{
JButton f1Button,f2Button,f3Button,f4Button,f5Button,f6Button;
JFileChooser chooser;
File File1,File2,File3,File4;
JPanel jp;
JMenuBar menubar = new JMenuBar();
JMenu file,help;
JMenuItem exit,about;

public static void main(String[] args)
{
	base64encoder b64e = new base64encoder(args);
}

public base64encoder(String[] args)
{
	super("Base64 encoder");
	f1Button = new JButton("encode from file...");
	f2Button = new JButton("encode to file...");
	f3Button = new JButton("encode");
	f4Button = new JButton("decode from file...");
	f5Button = new JButton("decode to file...");
	f6Button = new JButton("decode");
	file = new JMenu("File");
	help = new JMenu("Help");
	exit = new JMenuItem("Exit");
	about = new JMenuItem("About");
	file.add(exit);
	help.add(about);
	menubar.add(file);
	menubar.add(help);
	f1Button.addActionListener(this);
	f2Button.addActionListener(this);
	f3Button.addActionListener(this);
	f4Button.addActionListener(this);
	f5Button.addActionListener(this);
	f6Button.addActionListener(this);
	exit.addActionListener(this);
	about.addActionListener(this);
	jp = new JPanel();
	jp.setLayout(new GridLayout(2,3));
	jp.add(f1Button);
	jp.add(f2Button);
	jp.add(f3Button);
	jp.add(f4Button);
	jp.add(f5Button);
	jp.add(f6Button);
	getContentPane().setLayout(new BorderLayout());
	getContentPane().add("Center",jp);
	getContentPane().add("North",menubar);
	setResizable(false);
	pack();
	show();
	addWindowListener(this);
}

public void actionPerformed(ActionEvent e)
{
	if(e.getSource().equals(f1Button))
	{
		File1 = chooseFile(true);
	}
	else
	if(e.getSource().equals(f2Button))
	{
		File2 = chooseFile(false);
	}
	else
	if(e.getSource().equals(f3Button))
	{
		if(File1 != null && File2 != null)
		{
			try{
				if(!File2.exists())
				File2.createNewFile();
			}
			catch(Exception ex){JOptionPane.showMessageDialog(this,"<html><body><b><u><font color='blue'>base64 encoder exception:</font></u></b><br>" + ex + "</body></html>");}

			try{
				Base64.encode(File1,File2);
			}
			catch(Exception ex){JOptionPane.showMessageDialog(this,"<html><body><b><u><font color='blue'>base64 encoder exception:</font></u></b><br>" + ex + "</body></html>");}
		}
		else
		JOptionPane.showMessageDialog(this,"<html><body><b><u><font color='blue'>base64 encoder message:</font></u></b><br>Select an input and output file</body></html>");
	}
	else
	if(e.getSource().equals(f4Button))
	{
		File3 = chooseFile(true);
	}
	else
	if(e.getSource().equals(f5Button))
	{
		File4 = chooseFile(false);
	}
	else
	if(e.getSource().equals(f6Button))
	{
		if(File3 != null && File4 != null)
		{

			try{
				if(!File4.exists())
				File4.createNewFile();
			}
			catch(Exception ex){JOptionPane.showMessageDialog(this,"<html><body><b><u><font color='blue'>base64 encoder exception:</font></u></b><br>" + ex + "</body></html>");}

			try{
				Base64.decode(File3,File4);
			}
			catch(Exception ex){JOptionPane.showMessageDialog(this,"<html><body><b><u><font color='blue'>base64 encoder exception:</font></u></b><br>" + ex + "</body></html>");}
		}
		else
		JOptionPane.showMessageDialog(this,"<html><body><b><u><font color='blue'>base64 encoder message:</font></u></b><br>Select an input and output file</body></html>");
	}
	else
	if(e.getSource().equals(exit))
	{
		dispose();
		System.exit(0);
	}
	else
	if(e.getSource().equals(about))
	{
		JOptionPane.showMessageDialog(this,"<html><body><b><u><font color='blue'>About base64 encoder</font></u></b><br>This program is free software; you can redistribute it and/or <br>modify it under the terms of the GNU General Public License <br>as published by the Free Software Foundation; either version <br>2 of the License, or (at your option) any later version.<br><br>This program is based on code of Stephen Ostermiller <br>(<a href='http://ostermiller.org/utils/Base64.html'>http://ostermiller.org/utils/Base64.html</a>).</body></html>");
	}
}


public File chooseFile(boolean open)
{
	chooser = new JFileChooser();
	chooser.setDialogTitle("Choose a file");
	if(open)
	chooser.showOpenDialog(this);
	else
	chooser.showSaveDialog(this);
	return chooser.getSelectedFile();
}



public void windowClosing(WindowEvent evt){dispose();System.exit(0);}
public void windowClosed(WindowEvent evt){}
public void windowActivated(WindowEvent evt){}
public void windowDeactivated(WindowEvent evt){}
public void windowOpened(WindowEvent evt){}
public void windowIconified(WindowEvent evt){}
public void windowDeiconified(WindowEvent evt){}
}